package api.cms;

import api.util.JSON;
import jp.co.mintjams.osgi.service.jcr.script.ScriptingContext;

class Calculator {
	def context;
	def item;

	Calculator(context) {
		this.context = context;
	}

	static def create(ScriptingContext context) {
		return new Calculator(context);
	}

	def with(Item item) {
		this.item = item;
		return this;
	}

	def calculate() {
		if (!item) {
		    throw new java.lang.IllegalStateException("item");
		}

		def arguments = [
			"item" : item.toObject(),
			"facetDefinitions" : getFacetDefinitions()
		];

		def ScriptAPI = context.getAttribute("ScriptAPI");
		def resourceResolver = context.repositorySession.resourceResolver;
		def resultJson = ScriptAPI.createScript(resourceResolver.getResource("/WEB-INF/classes/api/cms/Calculator_calculate.es"))
			.setAsync(false)
			.setAttribute("parametersJson", JSON.stringify(arguments))
			.eval();
		def properties = JSON.parse(resultJson);
		if (!properties) {
			return;
		}

	    ItemHelper.create(context).with(this).importAttributes(metadata.properties);
	}

	def getFacetDefinitions() {
		def resourceResolver = context.repositorySession.resourceResolver;
		def facetDefinitions = [:];
		for (p in item.resource.properties) {
			def facetPath = "/WEB-INF/facets/" + p.name + ".yml";
			def facetResource = resourceResolver.getResource(facetPath);
			if (!facetResource.exists()) {
				continue;
			}

			def o = Item.create(context).with(facetResource).toObject();
			if (!o.facetDefinition) {
				continue;
			}
			facetDefinitions[p.name] = o.facetDefinition;
		}
		return facetDefinitions;
	}
}
