import api.http.WebRequest;
import api.http.WebResponse;
import api.security.User;

{->
	if (repositorySession.isAnonymous()) {
		// Unauthorized
		response.setStatus(401);
		return;
	}

	try {
		def params = WebRequest.create(request).parseRequest();
		if (!params.id || !params.newPassword) {
			// Bad Request
			response.setStatus(400);
			return;
		}

		def user = User.create(context).findByName(params.id);
		user.changePassword(params.newPassword);

		// commit
		conn.commit();

		// OK
		WebResponse.create(response).setStatus(200);
	} catch (Throwable ex) {
		log.error(ex.message, ex);
		// Unauthorized
		response.sendError(401, ex.message);
	}
}();
