import api.security.Authorizable;
import api.http.WebRequest;
import api.http.WebResponse;

{->
	if (repositorySession.isAnonymous()) {
		// Unauthorized
		response.setStatus(401);
		return;
	}

	def params = [
		"id": WebAPI.getParameter("id").defaultString(),
		"range": WebRequest.create(request).range
	];
	if (!params.id) {
		// Bad Request
		response.setStatus(400);
		return;
	}
	if (params.range && !params.range.isValid()) {
		// Bad Request
		response.setStatus(400);
		return;
	}

	try {
		def a = Authorizable.create(context).findByName(params.id);
		if (!a.contains("photo")) {
			// Not Found
			response.setStatus(404);
			return;
		}

		WebResponse
			.create(response)
			.setStatus(200)
			.enableContentCache()
			.setContentType(a.getBinaryType("photo"))
			.setContentLength(a.getBinaryLength("photo"))
			.setETag(a.getDate("lastModified").time as String)
			.writePartial(a.getStream("photo"), params.range);
	} catch (Throwable ex) {
		log.error(ex.message, ex);
		response.sendError(500, ex.message);
		return;
	}
}();
