import api.cms.Item;
import api.http.WebRequest;
import api.http.WebResponse;
import api.util.YAML;
import app.memo.Memo;

{->
	if (repositorySession.isAnonymous()) {
		// Unauthorized
		response.setStatus(401);
		return;
	}

	try {
		def appConfig = YAML.parse(resource.parent.parent.parent.getResource("app.yml"));
		def now = new Date();
		def params = WebRequest.create(request).parseRequest();
		def path = "/var/webtop/home/" + repositorySession.userID + "/appData/" + appConfig.identifier;
		def appFolder = Item.create(context).findByPath(path);
		appFolder.mkdirs();
		def identifier;
		def item;
		for (;;) {
			identifier = java.util.UUID.randomUUID().toString();
			item = appFolder.getItem(identifier + ".txt");
			if (!item.exists()) {
				break;
			}
		}
		item.createNewFile();
		item.setAttribute("memo.identifier", identifier);
		if (params.text) {
			item.setContent(params.text);
		}
		if (params.tag) {
			item.setAttribute("memo.tag", params.tag as String[]);
		}
		if (params.color) {
			item.setAttribute("memo.color", params.color);
		}

		item.setAttribute("jcr:lastModified", now);
		repositorySession.commit();

		def memoItem = Memo.create(context).with(item.resource);

		// OK
		WebResponse.create(response)
			.setStatus(200)
			.setContentType("application/json");
		out.print(memoItem.metadataAsJson);
		return;
	} catch (Throwable ex) {
		log.error(ex.message, ex);
		response.sendError(500, ex.message);
	} finally {
		try {
			repositorySession.rollback();
		} catch (Throwable ignore) {}
	}
}();
