import api.http.WebRequest;
import api.http.WebResponse;
import api.util.YAML;
import app.memo.Memo;
import groovy.json.JsonOutput;

{->
	if (repositorySession.isAnonymous()) {
		// Unauthorized
		response.setStatus(401);
		return;
	}

	try {
		def appConfig = YAML.parse(resource.parent.parent.parent.getResource("app.yml"));
		def resp = [
			"memos": []
		];

		def stmt = "/jcr:root/var/webtop/home/" + XPath.encodeXMLComponent(repositorySession.userID) + "/appData/" + XPath.encodeXMLComponent(appConfig.identifier) + "/element(*, nt:file)[";
		stmt += "jcr:content/@memo.identifier";
		stmt += "]";
		stmt += " order by @jcr:created descending";
		XPath.createQuery(stmt);
		def result = XPath.createQuery(stmt).execute();
		for (r in result.resources) {
			resp.memos.add(Memo.create(context).with(r).metadata);
		}

		// OK
		WebResponse.create(response)
			.setStatus(200)
			.setContentType("application/json");
		out.print(JsonOutput.toJson(resp));
		return;
	} catch (Throwable ex) {
		log.error(ex.message, ex);
		response.sendError(500, ex.message);
	}
}();
