import api.cms.Item;
import api.http.WebRequest;
import api.http.WebResponse;
import api.util.YAML;
import app.task.Task;

{->
	if (repositorySession.isAnonymous()) {
		// Unauthorized
		response.setStatus(401);
		return;
	}

	try {
		def appConfig = YAML.parse(resource.parent.parent.parent.getResource("app.yml"));
		def now = new Date();
		def params = WebRequest.create(request).parseRequest();
		def task = Task.create(context, appConfig).createNewFile();
		task.setSubject(params.subject);
		task.setComments(params.comments);
		task.setColor(params.color);
		task.setTags(params.tag);
		task.setDueDate(params.dueDate);
		task.setFollowUpDate(params.followUpDate);
		task.setAssignee(params.assignee);
		task.setCandidateUsers(params.candidateUser);
		task.setCandidateGroups(params.candidateGroup);
		task.setDraft(params.isDraft);

		task.setAttribute("jcr:lastModified", now);
		repositorySession.commit();

		// OK
		WebResponse.create(response)
			.setStatus(200)
			.setContentType("application/json");
		out.print(task.metadataAsJson);
		return;
	} catch (Throwable ex) {
		log.error(ex.message, ex);
		response.sendError(500, ex.message);
	} finally {
		try {
			repositorySession.rollback();
		} catch (Throwable ignore) {}
	}
}();
