import api.http.WebRequest;
import api.http.WebResponse;
import api.util.YAML;
import app.task.Task;
import groovy.json.JsonOutput;

{->
	if (repositorySession.isAnonymous()) {
		// Unauthorized
		response.setStatus(401);
		return;
	}

	try {
		def appConfig = YAML.parse(resource.parent.parent.parent.getResource("app.yml"));
		def resp = [
			"tasks": []
		];

		def stmt = "/jcr:root/var/webtop/apps/" + XPath.encodeXMLComponent(appConfig.identifier) + "/tasks//element(*, nt:file)[";
		stmt += "jcr:content/@task.identifier";
		stmt += " and jcr:content/@task.isTopic = " + XPath.value(true);
		stmt += " and jcr:content/@task.isDraft = " + XPath.value(true);
		stmt += "]";
		stmt += " order by @jcr:created";
		XPath.createQuery(stmt);
		def result = XPath.createQuery(stmt).execute();
		for (r in result.resources) {
			resp.tasks.add(Task.create(context, appConfig).with(r).metadata);
		}

		// OK
		WebResponse.create(response)
			.setStatus(200)
			.setContentType("application/json");
		out.print(JsonOutput.toJson(resp));
		return;
	} catch (Throwable ex) {
		log.error(ex.message, ex);
		response.sendError(500, ex.message);
	}
}();
