import api.cms.Item;
import api.http.WebRequest;
import api.http.WebResponse;
import api.util.YAML;
import app.task.Task;

{->
	if (repositorySession.isAnonymous()) {
		// Unauthorized
		response.setStatus(401);
		return;
	}

	try {
		def appConfig = YAML.parse(resource.parent.parent.parent.getResource("app.yml"));
		def now = new Date();
		def params = WebRequest.create(request).parseRequest();
		if (!params.identifier) {
			// Bad Request
			response.setStatus(400);
			return;
		}

		def task = Task.create(context, appConfig).findByIdentifier(params.identifier);
		if (!task.exists()) {
			// Not Found
			response.setStatus(404);
			return;
		}

		task.remove();
		repositorySession.commit();

		// No Content
		WebResponse.create(response).setStatus(204);
		return;
	} catch (Throwable ex) {
		log.error(ex.message, ex);
		response.sendError(500, ex.message);
	} finally {
		try {
			repositorySession.rollback();
		} catch (Throwable ignore) {}
	}
}();
